unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Tabs, PageForm, ExtCtrls, StdCtrls, Buttons;

const MAXNBKPAGES = 20;  { Maximum number of pages = 20 }

type
	TPageNumber = Byte;
	TExternalPages = set of TPageNumber;

  TForm1 = class(TForm)
	TabSet1: TTabSet;
	Panel1: TPanel;
	Panel2: TPanel;
	Notebook1: TNotebook;
    BitBtn1: TBitBtn;
	Bevel1: TBevel;
    Edit1: TEdit;
    Label1: TLabel;
	procedure TabSet1Change(Sender: TObject; NewTab: Integer;
	  var AllowChange: Boolean);
	procedure FormCreate(Sender: TObject);
	procedure FormDestroy(Sender: TObject);
	procedure FormShow(Sender: TObject);
  private
	ExternalPages: TExternalPages;
	FormCreated: array [0..MAXNBKPAGES-1] of TForm;
	{ Private declarations }
  public
	{ Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses unit2, unit3, unit4;
{$R *.DFM}

procedure TForm1.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
	if NewTab in ExternalPages then { If the new page is defined as external }
		begin
		LockWindowUpdate(Handle);
		if FormCreated[NewTab] = NIL then { If it is not created yet, create it }
			begin
				Case NewTab of
					{ The parent is Notebook1, the Owner is NoteBook1.Owner }
					0: FormCreated[NewTab] := TForm2.Create(NoteBook1);
					1: FormCreated[NewTab] := TForm3.Create(NoteBook1);
					2: FormCreated[NewTab] := TForm4.Create(NoteBook1);
				end;
			end;

		{ Hide the previously active page if it is an external page }
		if (TabSet1.TabIndex >= 0) and (FormCreated[TabSet1.TabIndex] <> NIL) then
			FormCreated[TabSet1.TabIndex].Hide;

		{ Show the new current page }
		FormCreated[NewTab].Show;
		LockWindowUpdate(0);
		end
	else
		begin
		{ if the new page is a normal page, just select it }
		NoteBook1.PageIndex := NewTab;

		{ Hide the previously active page if external }
		if FormCreated[TabSet1.TabIndex] <> NIL then
			begin
			LockWindowUpdate(Handle);
			FormCreated[TabSet1.TabIndex].Hide;
			LockWindowUpdate(0);
			end;
		end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	ExternalPages := [0, 1, 2]; { Pages that are defined as external }
	TabSet1.Tabs := NoteBook1.Pages;

	{ Zero-Fill the array of TForm References}
	FillChar(FormCreated, MAXNBKPAGES * sizeof(TForm), #0);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var iPageNum: Integer;
begin
	{ Deleting all the notebook pages created }
	 for iPageNum := 0 to MAXNBKPAGES - 1 do
		if FormCreated[iPageNum] <> NIL then
			FormCreated[iPageNum].Free;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
{   You enable this code if you want that the first active page to be an external page }
{	FormCreated[0] := TForm2.Create(NoteBook1);
	FormCreated[0].Show;
}

{   You enable this code if you want that the first active page to be an internal page }
	TabSet1.TabIndex := 3;
end;

end.
